# The tidiest /etc/hosts file ever

{ config, pkgs, ... }:

with pkgs.lib;

let

    # given a host..domain record (domainRec) return ip4/ip6 address
    getIP4 = record: record.ip4 or "";
    getIP6 = record: record.ip6 or "";

    dnsEntryFmtAll = getter: key: records: 
        let
            record = getAttr key records;
            ip = getter record;
            hostName = record.hostName;
            domainName = record.domainName;
            nickname = record.nickname;
            comment = record.comment or key;
        in
            if (record.needsHostsEntry)
                then if (ip != "") 
                        then "${ip} ${domainName} ${hostName} ${nickname}  # ${comment}"
                        else "#<no ip> ${domainName} ${hostName} ${nickname}  # ${comment}"
                else "";  

    # entry only if ip given
    dnsEntryFmt = getter: key: records: 
        let
            record = getAttr key records;
            ip = getter record;
            ipCol = padString 16 ip;
            domainName = if (record.domainName == "")
                     then "${record.hostName}.${config.dns.domain}"
                     else record.domainName;
            domainNameCol = padStringLeft 25 (domainName);
            hostNameCol = padString 12 (record.hostName);
            nicknameCol = padString 12 (record.nickname);
            comment = if record.comment != "" then  "${key} (${record.comment})" else "${key}";
        in
            if (ip != "" && record.needsHostsEntry) 
            then "${ipCol} ${domainNameCol} ${hostNameCol} ${nicknameCol}  # ${comment}"
            else "";
   

   

    dnsEntries = data: fmt: forEach (attrNames data) (k: (fmt k data) );

    dnsHosts = data: fmt: concatStringsSep "\n" (remove "" (naturalSort (dnsEntries data fmt)));
    
in

{
    networking.extraHosts = "\n# Generated by dns-hosts-scheme-2.nix\n" +
                            dnsHosts config.dns.hosts (dnsEntryFmt getIP4) + 
                            dnsHosts config.dns.hosts (dnsEntryFmt getIP6);
}
